/* i/o with line-number counters - SHK %W% %G% */
#include <stdio.h>
#include "Modified_cee.h"
#define _NFILE 20
INT _line_number[_NFILE]; /* line numbers for each of the open files */
#define Fclose(streamline) LineNumber(streamline)= -1; \
    IF fclose(streamline) == EOF \
    THEN fprintf(stderr, "cannot close stream #%d\n", fileno(streamline))\
    FI
#define Fopen(filename,mode,stream) \
    IF ((stream) = fopen(filename, mode)) == NULL \
    THEN fprintf(stderr,"Cannot open file %s on line %d of file %s\n", \
	filename, __LINE__, __FILE__); exit(1) \
    ELSE LineNumber(stream)=1 \
    FI
#define Freopen(filename,mode,stream) \
    IF (freopen(filename, mode, stream)) == NULL \
    THEN fprintf(stderr,"Cannot reopen file %s on line %d of file %s\n", \
	filename, __LINE__, __FILE__); exit(1) \
    ELSE LineNumber(stream)=1 \
    FI
#define LineNumber(stream) _line_number[fileno(stream)]
#define NewLine(stream) BEGIN CHAR c; \
    /* fprintf(stderr, "Newline skipping:");*/\
    WHILE (c = getc(stream)) != '\n' ANDIF (c != EOF) \
    DO  OD \
    LineNumber(stream) INCR \
    END
EXTERN LONG lseek();
#define Rewind(fildes) 	/* rewind file, given file descriptor (INT) */\
    IF lseek(fildes, 0L, 0) == -1	/* rewind the file */\
    THEN fprintf(stderr, "Error in attempting to rewind file.\n")\
    ELSE _line_number[fildes]=1; _iob[fildes]._cnt = 0;\
	_iob[fildes]._ptr = _iob[fildes]._base;\
	_iob[fildes]._flag &= ~(_IOERR|_IOEOF);\
	if (_iob[fildes]._flag & _IORW)\
	    _iob[fildes]._flag &= ~(_IOREAD|_IOWRT);\
    FI
#define SRewind(stream) 	/* rewind file, given FILE REF */\
    IF rewind(stream) == -1	/* rewind the file */\
    THEN fprintf(stderr, "Error in attempting to rewind file.\n")\
    ELSE LineNumber(stream)=1\
    FI
/* #define	MALLOC(type, num_elems, proc, errstring) \
    (type REF)Malloc((UNSIGNED) SIZEOF(type)*num_elems, proc, errstring) */
#define	REALLOC(object, type, num_elems, proc, errstring) \
    (type REF)realloc(object, (UNSIGNED) SIZEOF(type)*(num_elems))
#define	MALLOC(type, num_elems, proc, errstring) \
    (type REF)malloc((UNSIGNED) SIZEOF(type)*(num_elems))
/* #define	MALLOC(type, num_elems, proc, errstring) \
    (type REF)mallocMagic((UNSIGNED) SIZEOF(type)*(num_elems))
#define free(a) if (a && ((LONG)a != 0xffffffff)) (STRING)freeMagic(a); else {fprintf(stderr, "Attempt to free(%x)\n",a);fflush(stderr);abort();} */
#define free(a) if (a && ((LONG)a != 0xffffffff)) (STRING)free(a); else {fprintf(stderr, "Attempt to free(%x)\n",a);fflush(stderr);abort();}
